float4x4 worldMatrixArray[100]:WORLDMATARRAY;//boneTM array for each mesh
float4x4 vp:VIEWPROJECTION;
float3 freeLight:FREELIGHT;

Texture2D tex;

SamplerState defss
{
	AddressU = Wrap;
	AddressV = Wrap;
};

void MyVS(float3 pos:apos, float2 tc:atexcoord,
		  float3 normal:N, 
		  unsigned int4 bones:abones, float3 weight:aweights,
	out float4 opos:SV_POSITION, out float2 otc:TEX,
	out float3 onormal:NORMAL, out float3 olight:LIGHT)
{
	opos = float4(0,0,0,0);
	onormal = float4(0,0,0,0);
	
	int numBones = 4;
	int iBone = 0;
	float sumWeights = 1.0f;
	for(;iBone < numBones - 1; iBone++)
	{
		sumWeights -= weight[iBone];
		opos += mul( float4(pos, 1), worldMatrixArray[ bones[iBone] ]) * weight[iBone];
		onormal += mul(normal, (float3x3)worldMatrixArray[ bones[iBone] ]) * weight[iBone];
	}
	
	opos = mul(opos, vp);
	otc = tc;
	olight = normalize(freeLight - pos);
}

float4 MyPS(float4 pos:SV_POSITION, float2 tc:TEX,
			float3 normal:NORMAL, float3 light:LIGHT):SV_Target
{ 
   float3 normal2 = normalize(normal);
   float3 light2 = normalize(light);
	
   float Idiff = max( dot(normal2, light2), 0.1);

   return tex.Sample(defss, tc) * Idiff;
}

technique11 MyTechnique
{
    pass P0
    {          
		SetVertexShader(CompileShader(vs_4_0, MyVS()));
		SetPixelShader(CompileShader(ps_4_0, MyPS()));
		SetGeometryShader(NULL);
    }
}
