float4x4 mvp:WORLDVIEWPROJECTION;
float3 freeLight:FREELIGHT;

Texture2D tex;

SamplerState defss
{
	AddressU = Wrap;
	AddressV = Wrap;
};

void MyVS(float3 pos:apos, float2 tc:atexcoord,
		  float3 normal:N,
	out float4 opos:SV_POSITION, out float2 otc:TEX,
	out float3 onormal:NORMAL, out float3 olight:LIGHT)
{
	opos = mul(float4(pos, 1), mvp);
	otc = tc;
	onormal = normal;
	olight = normalize(freeLight - pos);
}

float4 MyPS(float4 pos:SV_POSITION, float2 tc:TEX,
			float3 normal:NORMAL, float3 light:LIGHT):SV_Target
{ 
   float3 normal2 = normalize(normal);
   float3 light2 = normalize(light);
	
   float Idiff = max( dot(normal2, light2), 0.1);

   return tex.Sample(defss, tc) * Idiff;
}

technique11 MyTechnique
{
    pass P0
    {          
		SetVertexShader(CompileShader(vs_4_0, MyVS()));
		SetPixelShader(CompileShader(ps_4_0, MyPS()));
		SetGeometryShader(NULL);
    }
}
